searchData={"items":[{"type":"module","title":"hackney_telemetry","doc":"Telemetry adapter for Hackney metrics. To use it, configure Hackney mod_metrics to use this module and make sure that the hackney_telemetry application starts before your application. Hackney calls the module specified by mod_metrics to report instrumentation metrics. This module receives the data from Hackney and passes it to a hackney_telemetry_worker which keeps the current state of the metric and generates Telemetry events. This module implements all the callbacks required by hackney_metrics. Hackney supports storing metrics in Folsom or Exometer. Unfortunately, these libraries libraries do not export data in a way that is useful for Telemetry, so we need to transform the metrics data before reporting it. Modules such as [Telemetry.Metrics](https://hex.pm/packages/telemetry_metrics) can create gauges and histograms, so we just need to keep track of metric values and report them to Telemetry. Metrics are identified by a name, which is a list of atoms or charlist strings, e.g.: - [hackney, free_count] - [hackney_pool, api_graphql, free_count] Metrics also have type: counter, histogram, gauge, or meter. For more information see: - https://github.com/benoitc/hackney/blob/master/README.md#metrics","ref":"hackney_telemetry.html"},{"type":"function","title":"hackney_telemetry.decrement_counter/1","doc":"Decrement counter metric by 1.","ref":"hackney_telemetry.html#decrement_counter/1"},{"type":"function","title":"hackney_telemetry.decrement_counter/2","doc":"Decrement counter metric by the given value.","ref":"hackney_telemetry.html#decrement_counter/2"},{"type":"function","title":"hackney_telemetry.delete/1","doc":"Delete metric worker.","ref":"hackney_telemetry.html#delete/1"},{"type":"function","title":"hackney_telemetry.increment_counter/1","doc":"Increment counter metric by 1.","ref":"hackney_telemetry.html#increment_counter/1"},{"type":"function","title":"hackney_telemetry.increment_counter/2","doc":"Increment counter metric by the given value.","ref":"hackney_telemetry.html#increment_counter/2"},{"type":"function","title":"hackney_telemetry.new/2","doc":"Create metric worker. Hackney calls this function when it creates a new pool. It spawns a worker process to handle the new metrics. Hackney general metrics are ignored here because they are already included in the hackney_telemetry_sup supervisor.","ref":"hackney_telemetry.html#new/2"},{"type":"function","title":"hackney_telemetry.update_gauge/2","doc":"Update gauge metric. Gauges only keep the latest value, so we just need to replace the old state.","ref":"hackney_telemetry.html#update_gauge/2"},{"type":"function","title":"hackney_telemetry.update_histogram/2","doc":"Update histogram metric.","ref":"hackney_telemetry.html#update_histogram/2"},{"type":"function","title":"hackney_telemetry.update_meter/2","doc":"Update meter metric. A meter is a type of counter that only goes forward.","ref":"hackney_telemetry.html#update_meter/2"},{"type":"type","title":"hackney_telemetry.hackney_metric/0","doc":null,"ref":"hackney_telemetry.html#t:hackney_metric/0"},{"type":"type","title":"hackney_telemetry.metric_type/0","doc":null,"ref":"hackney_telemetry.html#t:metric_type/0"},{"type":"module","title":"hackney_telemetry_app","doc":"hackney_telemetry application","ref":"hackney_telemetry_app.html"},{"type":"function","title":"hackney_telemetry_app.start/2","doc":null,"ref":"hackney_telemetry_app.html#start/2"},{"type":"function","title":"hackney_telemetry_app.stop/1","doc":null,"ref":"hackney_telemetry_app.html#stop/1"},{"type":"module","title":"hackney_telemetry_sup","doc":"hackney_telemetry application supervisor.","ref":"hackney_telemetry_sup.html"},{"type":"function","title":"hackney_telemetry_sup.init/1","doc":null,"ref":"hackney_telemetry_sup.html#init/1"},{"type":"function","title":"hackney_telemetry_sup.start_link/0","doc":null,"ref":"hackney_telemetry_sup.html#start_link/0"},{"type":"function","title":"hackney_telemetry_sup.start_worker/1","doc":"Start worker for the given metric under this supervisor.","ref":"hackney_telemetry_sup.html#start_worker/1"},{"type":"function","title":"hackney_telemetry_sup.stop_worker/1","doc":"Stop worker associated with the given metric name if it exists.","ref":"hackney_telemetry_sup.html#stop_worker/1"},{"type":"type","title":"hackney_telemetry_sup.hackney_metric/0","doc":null,"ref":"hackney_telemetry_sup.html#t:hackney_metric/0"},{"type":"module","title":"hackney_telemetry_worker","doc":"Worker process to handle a hackney metric. A worker process has two jobs: (1) Calculate metric values Hackney does not keep the state of its metrics, but instead emits events to the metrics engine, like &quot;increase this counter by 1&quot;, &quot;set this gauge to X&quot;, &quot;add Y to this histogram&quot;. The job of a metric worker is to process these events and keep up-to-date state representing the value of the tracked metric. State updates run in constant time (O(1)), important since a single request generates about nine metric updates. (2) Send metric values to Telemetry If we send the metric value to Telemetry after every update, then telemetry processing may not be able to keep up, and Telemetry will apply backpressure. Since the worker maintains the most up-to-date value, we can send the current value periodically. Gauge metrics may be less accurate, but it avoids overload. Start options: - metric: name of the metric as a list of atoms (required). - report_interval: how often the worker reports data to telemetry, in milliseconds. If set to 0, scheduled reports are disabled and the worker will report after every update. Defaults to the value configured in the hackney_telemetry/report_interval config.","ref":"hackney_telemetry_worker.html"},{"type":"function","title":"hackney_telemetry_worker.child_spec/1","doc":"Generate worker child spec for a supervisor.","ref":"hackney_telemetry_worker.html#child_spec/1"},{"type":"function","title":"hackney_telemetry_worker.code_change/3","doc":"gen_server code_change callback","ref":"hackney_telemetry_worker.html#code_change/3"},{"type":"function","title":"hackney_telemetry_worker.handle_call/3","doc":"gen_server handle_call implementation.","ref":"hackney_telemetry_worker.html#handle_call/3"},{"type":"function","title":"hackney_telemetry_worker.handle_cast/2","doc":"Handle update event","ref":"hackney_telemetry_worker.html#handle_cast/2"},{"type":"function","title":"hackney_telemetry_worker.handle_info/2","doc":"Handle report events","ref":"hackney_telemetry_worker.html#handle_info/2"},{"type":"function","title":"hackney_telemetry_worker.init/1","doc":"Initialize server state","ref":"hackney_telemetry_worker.html#init/1"},{"type":"function","title":"hackney_telemetry_worker.start_link/1","doc":"Start server","ref":"hackney_telemetry_worker.html#start_link/1"},{"type":"function","title":"hackney_telemetry_worker.terminate/2","doc":"gen_server terminate callback","ref":"hackney_telemetry_worker.html#terminate/2"},{"type":"function","title":"hackney_telemetry_worker.update/3","doc":"Update metric","ref":"hackney_telemetry_worker.html#update/3"},{"type":"function","title":"hackney_telemetry_worker.worker_name/1","doc":"Return name of the worker process","ref":"hackney_telemetry_worker.html#worker_name/1"},{"type":"type","title":"hackney_telemetry_worker.hackney_metric/0","doc":null,"ref":"hackney_telemetry_worker.html#t:hackney_metric/0"},{"type":"type","title":"hackney_telemetry_worker.keyword/0","doc":null,"ref":"hackney_telemetry_worker.html#t:keyword/0"},{"type":"type","title":"hackney_telemetry_worker.keywords/0","doc":null,"ref":"hackney_telemetry_worker.html#t:keywords/0"},{"type":"type","title":"hackney_telemetry_worker.transform_fun/0","doc":null,"ref":"hackney_telemetry_worker.html#t:transform_fun/0"},{"type":"extras","title":"Overview","doc":"![Tests](https://github.com/msramos/hackney_telemetry/actions/workflows/ci.yml/badge.svg)\n[![Contributor Covenant](https://img.shields.io/badge/Contributor%20Covenant-2.1-4baaaa.svg)](CODE_OF_CONDUCT.md)\n\n> [!IMPORTANT]\n> This is the new upstream of this project. The [TheRealReal](https://github.com/TheRealReal/hackney_telemetry) repository will no longer be mantained.\n\n# hackney_telemetry\n\nTelemetry adapter for Hackney metrics.\n\nThis module is a [metrics handler](https://github.com/benoitc/hackney/blob/master/README.md#metrics)\nfor the [Hackney](https://github.com/benoitc/hackney) HTTP client. It receives\ncalls from Hackney to update metrics and generates [Telemetry](https://github.com/beam-telemetry/telemetry) events.\n\nHackney supports storing metrics in [Folsom](https://hex.pm/packages/folsom) or\n[Exometer](https://hex.pm/packages/exometer_core). Unfortunately, these\nlibraries do not export data in a way that is useful for Telemetry,\nso we need to transform the metrics data before reporting it.","ref":"readme.html"},{"type":"extras","title":"Telemetry metrics - Overview","doc":"The following metrics are exported by this library to telemetry.\n\n| Metric                      | Tags | Meaning                                               |\n| --------------------------- | ---- | ----------------------------------------------------- |\n| `hackney.nb_requests`       | -    | Current number of requests                            |\n| `hackney.finished_requests` | -    | Total number of finished requests                     |\n| `hackney.total_requests`    | -    | Total number of requests                              |\n| `hackney_pool.free_count`   | pool | Number of free sockets in a connection pool           |\n| `hackney_pool.in_use_count` | pool | Number of busy sockets in a connection pool           |\n| `hackney_pool.no_socket`    | pool | Count of new connections                              |\n| `hackney_pool.queue_count`  | pool | Number of requests waiting for a connection in a pool |\n| `hackney_pool.take_rate`    | pool | Rate at which a connection is retrieved from the pool |\n\nThis module implements all the callbacks required by `hackney_metrics` but it does\nnot support host metrics.\n\nTo use it, configure Hackney `mod_metrics` to use this module and make sure\nthat the `hackney_telemetry` application starts before your application.\n\nHackney calls the module specified by `mod_metrics` to report instrumentation\nmetrics. This module receives the data from Hackney and passes it to a\n`hackney_telemetry_worker` which keeps the current state of the metric and\ngenerates Telemetry events.\n\nA worker process has two jobs:\n\n1.  Calculate metric values\n\n    Hackney does not keep the state of its metrics, but instead emits events to\n    the metrics engine, like \"increase this counter by 1\", \"set this gauge to X\",\n    \"add Y to this histogram\". The job of a metric worker is to process these\n    events and keep up-to-date state representing the value of the tracked metric.\n    State updates run in constant time (O(1)), important since a single\n    request generates about nine metric updates.\n\n2.  Send metric values to Telemetry\n\n    If we send the metric value to Telemetry after every update, then\n    telemetry processing may not be able to keep up, and Telemetry will apply\n    backpressure.\n\n    Since the worker maintains the most up-to-date value, we can send the current\n    value periodically. Gauge metrics may be less accurate, but it avoids overload.","ref":"readme.html#telemetry-metrics"},{"type":"extras","title":"Installation - Overview","doc":"Install it from [Hex](https://hex.pm/packages/hackney_telemetry) or\n[Github](https://github.com/msramos/hackney_telemetry).","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Overview","doc":"Configure set Hackney to send metrics to this module:\n\n**Erlang**\n\n```erlang\n{hackney, [{mod_metrics, hackney_telemetry}]}\n```\n\n**Elixir**\n\n```elixir\nconfig :hackney, mod_metrics: :hackney_telemetry\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Options - Overview","doc":"#### Report interval\n\nBy default, workers will report data to telemetry every 1000 milliseconds.\nIf set to 0, events are generated after every update.\n\nYou can change that by setting the `report_interval` option:\n\n**Erlang**\n\n```erlang\n{hackney_telemetry, [{report_interval, 2000}]}\n```\n\n**Elixir**\n\n```elixir\nconfig :hackney_telemetry, report_interval: 2_000\n```","ref":"readme.html#options"},{"type":"extras","title":"Usage - Overview","doc":"After installing the module, your application will receive Telemetry events.\nYou can handle them in your application, or install a reporting module such\nas [Telemetry.Metrics](https://hex.pm/packages/telemetry_metrics)\nor [prom_ex](https://hex.pm/packages/prom_ex).","ref":"readme.html#usage"},{"type":"extras","title":"Elixir - Overview","doc":"```elixir\ndefmodule YourApplcation.Telemetry do\n  import Telemetry.Metrics\n\n  def metrics do\n  [\n    # other metrics\n\n    last_value(\"hackney.nb_requests\"),\n    last_value(\"hackney.finished_requests\"),\n    last_value(\"hackney.total_requests\"),\n    last_value(\"hackney_pool.free_count\", tags: [:pool]),\n    last_value(\"hackney_pool.in_use_count\", tags: [:pool]),\n    last_value(\"hackney_pool.no_socket\", tags: [:pool]),\n    last_value(\"hackney_pool.queue_count\", tags: [:pool]),\n    last_value(\"hackney_pool.take_rate\", tags: [:pool])\n  ]\n  end\nend\n```","ref":"readme.html#elixir"},{"type":"extras","title":"Building - Overview","doc":"To build the source code locally you'll need [rebar3](https://github.com/erlang/rebar3):\n\n```\nrebar3 compile\n```","ref":"readme.html#building"},{"type":"extras","title":"Test - Overview","doc":"```console\nrebar3 ct\n```","ref":"readme.html#test"},{"type":"extras","title":"Docs - Overview","doc":"```console\nrebar3 ex_doc\n```","ref":"readme.html#docs"},{"type":"extras","title":"Format code - Overview","doc":"```console\nrebar3 format\n```","ref":"readme.html#format-code"},{"type":"extras","title":"Code of Conduct - Overview","doc":"This project  Contributor Covenant version 2.1. Check [CODE_OF_CONDUCT.md](CODE_OF_CONDUCT.md) file for more information.","ref":"readme.html#code-of-conduct"},{"type":"extras","title":"License - Overview","doc":"`hackney_telemetry` source code is released under Apache License 2.0.\n\nCheck [NOTICE](NOTICE) and [LICENSE](LICENSE) files for more information.","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [0.2.0] - 2024-07-08","ref":"changelog.html"},{"type":"extras","title":"Changed - Changelog","doc":"- Change project ownership\n- Update testing matrix with Erlang 26 and 27 on github CI\n- Use telemetry `~> 1.0` instead of `~ 1.0.0`\n- Drop `rebar3_steamroll` in favor of `erlfmt`\n- Reformat whole project\n\n## [0.1.2] - 2022-09-19","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"- Update docs\n- Build docs with ex_doc\n- Update specs to successfully run Dialyzer\n- Update GitHub action to use caching and run Dializer\n\n## [0.1.1] - 2021-12-10","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"Minor update.","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix histogram values shift for `in_use_count` and `free_count metrics`\n\n## [0.1.0] - 2021-12-08","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- First version!\n- Metrics collector for hackney global and pool metrics","ref":"changelog.html#added"},{"type":"extras","title":"Code of Conduct","doc":"# Contributor Covenant Code of Conduct","ref":"code_of_conduct.html"},{"type":"extras","title":"Our Pledge - Code of Conduct","doc":"We as members, contributors, and leaders pledge to make participation in our\ncommunity a harassment-free experience for everyone, regardless of age, body\nsize, visible or invisible disability, ethnicity, sex characteristics, gender\nidentity and expression, level of experience, education, socio-economic status,\nnationality, personal appearance, race, caste, color, religion, or sexual\nidentity and orientation.\n\nWe pledge to act and interact in ways that contribute to an open, welcoming,\ndiverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge"},{"type":"extras","title":"Our Standards - Code of Conduct","doc":"Examples of behavior that contributes to a positive environment for our\ncommunity include:\n\n* Demonstrating empathy and kindness toward other people\n* Being respectful of differing opinions, viewpoints, and experiences\n* Giving and gracefully accepting constructive feedback\n* Accepting responsibility and apologizing to those affected by our mistakes,\n  and learning from the experience\n* Focusing on what is best not just for us as individuals, but for the overall\n  community\n\nExamples of unacceptable behavior include:\n\n* The use of sexualized language or imagery, and sexual attention or advances of\n  any kind\n* Trolling, insulting or derogatory comments, and personal or political attacks\n* Public or private harassment\n* Publishing others' private information, such as a physical or email address,\n  without their explicit permission\n* Other conduct which could reasonably be considered inappropriate in a\n  professional setting","ref":"code_of_conduct.html#our-standards"},{"type":"extras","title":"Enforcement Responsibilities - Code of Conduct","doc":"Community leaders are responsible for clarifying and enforcing our standards of\nacceptable behavior and will take appropriate and fair corrective action in\nresponse to any behavior that they deem inappropriate, threatening, offensive,\nor harmful.\n\nCommunity leaders have the right and responsibility to remove, edit, or reject\ncomments, commits, code, wiki edits, issues, and other contributions that are\nnot aligned to this Code of Conduct, and will communicate reasons for moderation\ndecisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities"},{"type":"extras","title":"Scope - Code of Conduct","doc":"This Code of Conduct applies within all community spaces, and also applies when\nan individual is officially representing the community in public spaces.\nExamples of representing our community include using an official e-mail address,\nposting via an official social media account, or acting as an appointed\nrepresentative at an online or offline event.","ref":"code_of_conduct.html#scope"},{"type":"extras","title":"Enforcement - Code of Conduct","doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be\nreported to the community leaders responsible for enforcement at\nrms.mrcs@gmail.com. All complaints will be reviewed and investigated\npromptly and fairly.\n\nAll community leaders are obligated to respect the privacy and security of the\nreporter of any incident.","ref":"code_of_conduct.html#enforcement"},{"type":"extras","title":"Enforcement Guidelines - Code of Conduct","doc":"Community leaders will follow these Community Impact Guidelines in determining\nthe consequences for any action they deem in violation of this Code of Conduct:","ref":"code_of_conduct.html#enforcement-guidelines"},{"type":"extras","title":"1. Correction - Code of Conduct","doc":"**Community Impact**: Use of inappropriate language or other behavior deemed\nunprofessional or unwelcome in the community.\n\n**Consequence**: A private, written warning from community leaders, providing\nclarity around the nature of the violation and an explanation of why the\nbehavior was inappropriate. A public apology may be requested.","ref":"code_of_conduct.html#1-correction"},{"type":"extras","title":"2. Warning - Code of Conduct","doc":"**Community Impact**: A violation through a single incident or series of\nactions.\n\n**Consequence**: A warning with consequences for continued behavior. No\ninteraction with the people involved, including unsolicited interaction with\nthose enforcing the Code of Conduct, for a specified period of time. This\nincludes avoiding interactions in community spaces as well as external channels\nlike social media. Violating these terms may lead to a temporary or permanent\nban.","ref":"code_of_conduct.html#2-warning"},{"type":"extras","title":"3. Temporary Ban - Code of Conduct","doc":"**Community Impact**: A serious violation of community standards, including\nsustained inappropriate behavior.\n\n**Consequence**: A temporary ban from any sort of interaction or public\ncommunication with the community for a specified period of time. No public or\nprivate interaction with the people involved, including unsolicited interaction\nwith those enforcing the Code of Conduct, is allowed during this period.\nViolating these terms may lead to a permanent ban.","ref":"code_of_conduct.html#3-temporary-ban"},{"type":"extras","title":"4. Permanent Ban - Code of Conduct","doc":"**Community Impact**: Demonstrating a pattern of violation of community\nstandards, including sustained inappropriate behavior, harassment of an\nindividual, or aggression toward or disparagement of classes of individuals.\n\n**Consequence**: A permanent ban from any sort of public interaction within the\ncommunity.","ref":"code_of_conduct.html#4-permanent-ban"},{"type":"extras","title":"Attribution - Code of Conduct","doc":"This Code of Conduct is adapted from the [Contributor Covenant][homepage],\nversion 2.1, available at\n[https://www.contributor-covenant.org/version/2/1/code_of_conduct.html][v2.1].\n\nCommunity Impact Guidelines were inspired by\n[Mozilla's code of conduct enforcement ladder][Mozilla CoC].\n\nFor answers to common questions about this code of conduct, see the FAQ at\n[https://www.contributor-covenant.org/faq][FAQ]. Translations are available at\n[https://www.contributor-covenant.org/translations][translations].\n\n[homepage]: https://www.contributor-covenant.org\n[v2.1]: https://www.contributor-covenant.org/version/2/1/code_of_conduct.html\n[Mozilla CoC]: https://github.com/mozilla/diversity\n[FAQ]: https://www.contributor-covenant.org/faq\n[translations]: https://www.contributor-covenant.org/translations","ref":"code_of_conduct.html#attribution"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   Copyright (c) 2023, Marcos Ramos.\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"},{"type":"extras","title":"NOTICE","doc":"Copyright 2023 Marcos Ramos\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n   https://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"notice.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}